namespace Programming_CSharp
{
	using System;

	public enum comparison
	{
		theFirstComesFirst = 1,
		theSecondComesFirst = 2
	}

	//  ü ϱ   ÷
	public class Pair
	{
		//  
		public delegate comparison 
			WhichIsFirst(object obj1, object obj2);

		// ڴ  ü ޾  Ѵ.
		public Pair(
			object firstObject, 
			object secondObject)
		{
			thePair[0] = firstObject;
			thePair[1] = secondObject;
		}

		//  ü ޾Ƽ Ÿ ؿ  ϴ  ޼ҵ
		public void Sort(
			WhichIsFirst theDelegatedFunc)
		{
			if (theDelegatedFunc(thePair[0],thePair[1]) 
				== comparison.theSecondComesFirst)
			{
				object temp = thePair[0];
				thePair[0] = thePair[1];
				thePair[1] = temp;
			}
		}

		// Sort()   ϴ ޼ҵ
		public void ReverseSort(
			WhichIsFirst theDelegatedFunc)
		{
			if (theDelegatedFunc(thePair[0],thePair[1]) == 
				comparison.theFirstComesFirst)
			{
				object temp = thePair[0];
				thePair[0] = thePair[1];
				thePair[1] = temp;
			}
		}

		//  ü ڿ  ȯѴ.
		public override string ToString()
		{
			return thePair[0].ToString() + ", " 
				+ thePair[1].ToString();
		}


		//  ü ϱ   迭
		private object[] thePair = new object[2];  
	}

	public class Dog
	{
		public Dog(int weight)
		{
			this.weight=weight;
		}

		//  ü߿  ĵȴ.
		public static comparison WhichDogComesFirst(
			Object o1, Object o2)
		{
			Dog d1 = (Dog) o1;
			Dog d2 = (Dog) o2;
			return d1.weight > d2.weight ? 
				comparison.theSecondComesFirst : 
				comparison.theFirstComesFirst;
		}
		public override string ToString()
		{
			return weight.ToString();
		}
		private int weight;
	}

	public class Student
	{
		public Student(string name)
		{
			this.name = name;
		}

		// л ĺ  ĵȴ.
		public static comparison 
			WhichStudentComesFirst(Object o1, Object o2)
		{
			Student s1 = (Student) o1;
			Student s2 = (Student) o2;
			return (String.Compare(s1.name, s2.name) < 0 ? 
				comparison.theFirstComesFirst : 
				comparison.theSecondComesFirst);
		}

		public override string ToString()
		{
			return name;
		}
		private string name;
	}

	public class Test
	{
		public static void Main()
		{
			// л ,   Ͽ Pair ü ߰Ѵ.
			Student Jesse = new Student("Jesse");
			Student Stacey = new Student ("Stacey");
			Dog Milo = new Dog(65);
			Dog Fred = new Dog(12);

			Pair studentPair = new Pair(Jesse,Stacey);
			Pair dogPair = new Pair(Milo, Fred);
			Console.WriteLine("studentPair\t\t\t: {0}", 
				studentPair.ToString());
			Console.WriteLine("dogPair\t\t\t\t: {0}", 
				dogPair.ToString());

			//  νϽ Ѵ.
			Pair.WhichIsFirst  theStudentDelegate = 
				new Pair.WhichIsFirst(
				Student.WhichStudentComesFirst);

			Pair.WhichIsFirst theDogDelegate =
				new Pair.WhichIsFirst(
				Dog.WhichDogComesFirst);

			//  ޼ҵ带 Ͽ Ѵ.
			studentPair.Sort(theStudentDelegate);
			Console.WriteLine("After Sort studentPair\t\t: {0}", 
				studentPair.ToString());
			studentPair.ReverseSort(theStudentDelegate);
			Console.WriteLine("After ReverseSort studentPair\t: {0}", 
				studentPair.ToString());
	
			dogPair.Sort(theDogDelegate);
			Console.WriteLine("After Sort dogPair\t\t: {0}", 
				dogPair.ToString());
			dogPair.ReverseSort(theDogDelegate);
			Console.WriteLine("After ReverseSort dogPair\t: {0}", 
				dogPair.ToString());
		}
	}
}

